#!/usr/bin/env python

#Crosslinker FM Copyright (c) 2015 JJ Posti <techtimejourney.net> 
#Crosslinker is a python file manager.The program comes with ABSOLUTELY NO WARRANTY; 
#for details see: http://www.gnu.org/copyleft/gpl.html. 
#This is free software, and you are welcome to redistribute it under 
#GPL Version 2, June 1991")

#Gtk.STOCK_PAGE_SETUP

#IMPORTING MODULES
from gi.repository import Gtk, Gdk, GObject

import pygtk, os, subprocess, shutil, errno, tarfile,zipfile, bz2, sys, pygtk
from os.path import basename
from bz2 import decompress
pygtk.require('2.0')

class CrosslinkerFM(Gtk.Window):
	
###Button press for compress "menu"

    def button_press(self, widget, event):
        if event.type == Gtk.gdk.BUTTON_PRESS and event.button == 3:
            #make widget popup
            widget.popup(None, None, None, event.button, event.time)
            pass

################################
#MIIMO TOOL INTEGRATION STARTS
##################################
#####Decompression
    def decompression (self,widget):
        global archive
        archive=str(self.filea.get_filename())									
        if archive.endswith ("tar.bz2"): 
           print archive
           goingdest=self.filea.get_current_folder()
           os.chdir(goingdest)
           current=self.filea.set_current_folder(goingdest)
           print current
           gets0=tarfile.open("%s" % archive , 'r:bz2')
           print gets0
           gets0.extractall('decompressed')
           print os.listdir('decompressed')
           
        elif archive.endswith ("tar.gz"): 
           print archive
           goingdest=self.filea.get_current_folder()
           os.chdir(goingdest)
           current=self.filea.set_current_folder(goingdest)
           print current
           gets0=tarfile.open("%s" % archive , 'r:gz')
           print gets0
           gets0.extractall('decompressed')
           print os.listdir('decompressed')
           
        elif archive.endswith ("zip"): 
           print archive
           goingdest=self.filea.get_current_folder()
           os.chdir(goingdest)
           current=self.filea.set_current_folder(goingdest)
           print current
           gets0=zipfile.ZipFile("%s" % archive ,)
           print gets0
           gets0.extractall('decompressed')
           print os.listdir('decompressed')
        		              

#####Compression
    def targz(self,widget):
        archive=str(self.filea.get_filename())
        print archive
        basic=os.path.splitext(archive)[0]
        print basic
        goingdest=self.filea.get_current_folder()
        os.chdir(goingdest)
        current=self.filea.set_current_folder(goingdest)
        current
        print current
        gets0=tarfile.open("%s.tar.gz" % basic , 'w:gz')
        print gets0
        gets0
        for name in [archive]:
            gets0.add(name)
        gets0.close()
		
    def tarbz2(self,widget):
        archive=str(self.filea.get_filename())	
        print archive
        basic=os.path.splitext(archive)[0]
        print basic
        goingdest=self.filea.get_current_folder()
        os.chdir(goingdest)
        current=self.filea.set_current_folder(goingdest)
        current
        print current
        gets0=tarfile.open("%s.tar.bz2" % basic , 'w:bz2')
        print gets0
        gets0
        for name in [archive]:
            gets0.add(name)
        gets0.close()
		
    def zips(self,widget):
        try:
            goingdest=self.filea.get_current_folder()
            os.chdir(goingdest)
            current=self.filea.set_current_folder(goingdest)
            current
            gets0=shutil.make_archive(os.getcwd(), 'zip')
            print gets0
            gets0
        except OSError as e:
            if e.errno == errno.ENOTDIR:
                global archive
                archive=str(self.filea.get_filename())
                print archive
                basic=os.path.splitext(archive)[0]
                print basic	
                goingdest=self.filea.get_current_folder()
                os.chdir(goingdest)
                current=self.filea.set_current_folder(goingdest)
                gets0=zipfile.ZipFile("%s.zip" % basic , mode='w')
                print gets0
                gets0
                for name in [archive]:
				gets0.write(name)
                gets0.close()
                
#################################        
#MIIMO TOOL INTEGRATION PARTS ENDS		
#################################
  
###################
#RENAME FUNCTION
##################
 
    def rename_selects(self,widget):
        global sourcemove
        sourcemove=self.filea.get_filename()
        self.renamer.set_text(sourcemove)
        print sourcemove
   	    
    def actual_rename (self, widget, data=None):
        msg=("If an object with the same name is found on the rename destination it will be overwritten. Are you sure you want to continue?")

        destroy_dialog = Gtk.MessageDialog (None, 0, Gtk.MessageType.INFO,
                                    Gtk.ButtonsType.OK_CANCEL, msg)
        destroy_dialog.set_title("Rename an object?")
        response = destroy_dialog.run()
        destroy_dialog.destroy()                            
        if response == Gtk.ResponseType.OK:			
            global getsit1
            getsit1=self.renamer.get_text()
            done=os.renames(sourcemove,getsit1)
            return False # returning False and make destroy-event

        else:
            return True # returning True and avoid "destroy-event" 
				
###########################
#LOCATION FUNCTION  
#######################

    def going(self,widget):
        global goingdest
        goingdest=self.filea.get_current_folder()
        os.chdir(goingdest)
        self.location1.set_text(goingdest)
        print goingdest
   	    
    def actual_going(self,widget):		
        global get_going
        get_going=self.location1.get_text()
        hereigo=str(os.chdir(get_going))
        self.filea.set_current_folder(hereigo)
 
  
######################
#MOVE FUNCTION
######################
#Move function
    def movesource(self,widget):
        global sourcemove2
        sourcemove2=self.filea.get_filename()
		
    def movedestination(self, widget, data=None):
        msg=("If an object with the same name is found on the move destination it will be overwritten. Are you sure you want to continue?")
        
        destroy_dialog = Gtk.MessageDialog (None, 0, Gtk.MessageType.INFO,
                                    Gtk.ButtonsType.OK_CANCEL, msg)
        destroy_dialog.set_title("Move an object?")
        response = destroy_dialog.run()
        destroy_dialog.destroy()                            
        if response == Gtk.ResponseType.OK:			
		    movedest=self.filea.get_current_folder()
		    os.chdir(movedest)
		    shutil.move(sourcemove2,movedest)
		    return False # returning False and make destroy-event

        else:
            return True # returning True and avoid "destroy-event" 
##################################
#PASTE FUNCTION
##########################

    def copydestination(self, widget, data=None):
        msg=("If an object with the same name is found on the paste destination it will be overwritten. Are you sure you want to continue?")
        destroy_dialog = Gtk.MessageDialog (None, 0, Gtk.MessageType.INFO,
                                    Gtk.ButtonsType.OK_CANCEL, msg)
        destroy_dialog.set_title("Paste an object?")
        response = destroy_dialog.run()
        destroy_dialog.destroy()                            
        if response == Gtk.ResponseType.OK:
            try:
                copydest=self.filea.get_current_folder()
                os.chdir(copydest)
                subprocess.Popen(['cp', '-r', sourcemove2 , copydest])
            except OSError as e:
                if e.errno == errno.ENOTDIR:		
                    copydest=self.filea.get_current_folder()
                    os.chdir(copydest)
                    shutil.copy(sourcemove2,copydest)
                    return False # returning False and make destroy-event
            else:
                   return True # returning True and avoid "destroy-event"                       			              
##############################
#CREATE OBJECT FUNCTIONS
#################################
#Make new directory
    def newdir(self,widget):
		foldername=self.filea.get_current_folder()
		os.chdir(foldername)
		makefolder=os.makedirs('Newfolder')
		print os.getcwd()
		makefolder           

#Make new empty text file
    def newfile(self,widget):
        foldername=self.filea.get_current_folder()
        os.chdir(foldername)
        newtext=os.mknod('Newtext.txt')
        print os.getcwd()
        newtext
####################
#DELETE FUNCTIONS
##########################
#Destroy/Delete function
   
    def foreverdelete (self, widget, data=None):
        msg=("Delete THIS PERMANENTLY?")
        destroy_dialog = Gtk.MessageDialog (None, 0, Gtk.MessageType.INFO,
                                    Gtk.ButtonsType.OK_CANCEL, msg)
        destroy_dialog.set_title("DELETE CONTENT PERMANENTLY?")
        response = destroy_dialog.run()
        destroy_dialog.destroy()                            
        if response == Gtk.ResponseType.OK:
            try:
                foldername=self.filea.get_filename()
                shutil.rmtree(foldername)
            except OSError as e:
                if e.errno == errno.ENOTDIR:
                    filename=self.filea.get_filename()
                    os.remove(filename)
            return False # returning False and make destroy-event

        else:
            return True # returning True and avoid "destroy-event"

###########################################################################
#POWER MANAGEMENT FUNCTIONS
############################################
#Shutdown function
    def power(self,widget):
		subprocess.Popen(['gksudo', 'poweroff'])
	
#Reboot function
    def reboot(self,widget):
        subprocess.Popen(['gksudo', 'reboot'])
        
#Suspend function
    def suspend(self,widget):
        subprocess.Popen(['gksudo', 'pm-suspend'])
###########################################################
#GENERAL FUNCTIONS
#####################################
#Close function
    def destroy (self, widget, data=None):
        Gtk.main_quit()
            	        
#About dialog function
    def about1 (self, widget):
        about1 = Gtk.AboutDialog()
        about1.set_program_name("Crosslinker FM")
        about1.set_version("V.Revision 2-Gtk3")
        about1.set_copyright(" Copyright (c) 2015 JJ Posti <techtimejourney.net>")
        about1.set_comments("Crosslinker is a python file-manager.The program comes with ABSOLUTELY NO WARRANTY; for details see: http://www.gnu.org/copyleft/gpl.html. This is free software, and you are welcome to redistribute it under GPL Version 2, June 1991. Crosslinker FM contains parts of Miimo Tool Copyright (C) 2015 JJ Posti. Miimo Tool is licensed under GPL Version 3, 29 June 2007")
        about1.set_website("www.techtimejourney.net")
        about1.run()
        about1.destroy()

#Simple mount function
    def mount (self, widget):
        mount=subprocess.Popen(['x-terminal-emulator', '-x', 'bash', '/usr/share/mount.sh'])

#Terminal menu item function
    def terminal (self, widget):
        terminal=subprocess.Popen(["x-terminal-emulator"])
                		 
#Screen off function
    def off (self, widget):
        locked=subprocess.Popen(['i3lock', '-c', '39393a', '-n'])               
##############################################################################
###OPEN WITH FUNCTIONS
########################

#OPEN WITH Unified
    def dialog_open (self,widget):
        filename=self.filea.get_filename()
        if filename.endswith("pdf"):
            subprocess.Popen(['qpdfview', filename])
        elif filename.endswith("abw"):
            subprocess.Popen(['abiword', filename])
        elif filename.endswith("odt"):
           subprocess.Popen(['abiword', filename])
        elif filename.endswith("txt"):
            subprocess.Popen(['geany', filename])
        elif filename.endswith("png"):
            subprocess.Popen(['feh', filename])
        elif filename.endswith("jpg"):
            subprocess.Popen(['feh', filename])  
        elif filename.endswith("ogg"):
            subprocess.Popen(['vlc', filename])
        elif filename.endswith("mp3"):
            subprocess.Popen(['vlc', filename])
        elif filename.endswith("mp4"):
            subprocess.Popen(['vlc', filename])
        elif filename.endswith("avi"):
            subprocess.Popen(['vlc', filename])
        elif filename.endswith("midi"):
            subprocess.Popen(['vlc', filename])
        elif filename.endswith("xcf"):
            subprocess.Popen(['gimp', filename])
        elif filename.endswith("mpg"):
            subprocess.Popen(['vlc', filename])
        elif filename.endswith("mp2"):
            subprocess.Popen(['vlc', filename])                                                                                                                     				
     
              
####################################
#STARTING WINDOW DEFINITIONS
#################################
#GENERAL STUFF
#################################    
    def __init__(self):    
    # Create THE WINDOW
        self.window1=Gtk.Window()
        self.window1.set_position(Gtk.WindowPosition.CENTER)
        self.window1.set_title("Crosslinker FM")
#Toolbars
        self.toolbar=Gtk.Toolbar()
        self.toolbar2=Gtk.Toolbar()
        self.toolbar3=Gtk.Toolbar()
        self.toolbar4=Gtk.Toolbar()


#Create menubar
        self.bar=Gtk.MenuBar()

###############################
#FILE MANAGER
#################################       
# Create a new file selection widget        
        self.filea = Gtk.FileChooserWidget()      
#Additional features
        self.filea.set_current_folder("/home/")
        self.filea.set_select_multiple(True)                                 
################################
###MENUS
###############

###FILE MENU
    #Create menu items for File menu

        self.file_menu=Gtk.Menu()
        self.filemenu=Gtk.MenuItem("File")
        self.filemenu.set_submenu(self.file_menu)
 
#Buttons for File menu

#Close button for file menu

        self.away=Gtk.MenuItem("Close")
        self.away.connect("activate", Gtk.main_quit)

#About button for file menu

        self.about=Gtk.MenuItem("About")
        self.about.connect("activate", self.about1)
        
#Appending things to File_menu        
        self.file_menu.append(self.about)
        self.file_menu.append(self.away)
#############################
####ADMIN MENU
#############################
#Create menu items for File menu
        
        self.admin1=Gtk.Menu()
        self.admin=Gtk.MenuItem("Admin")
        self.admin.set_submenu(self.admin1)		

#Buttons for admin menu

#Terminal button for admin menu
        self.menuterm=Gtk.MenuItem("Open terminal")
        self.menuterm.connect("activate", self.terminal)
 
# Power button
        self.powers= Gtk.MenuItem("Poweroff computer")
        self.powers.connect("activate", self.power)
        
# Reboot button
        self.reboots= Gtk.MenuItem("Reboot computer")
        self.reboots.connect("activate", self.reboot)
        
# Suspend button
        self.suspends= Gtk.MenuItem("Suspend computer")
        self.suspends.connect("activate", self.suspend)     

#Appending things to Admin menu
		
        self.admin1.append(self.menuterm)
        self.admin1.append(Gtk.SeparatorMenuItem())
        self.admin1.append(self.suspends)
        self.admin1.append(self.reboots)
        self.admin1.append(self.powers)
######################################################
#Appending items to menubar
        self.bar.append(self.filemenu)
        self.bar.append(self.admin)

#######################################################

######################################################
#BUTTONS APPEARING ON THE FILE MANAGER TOOLBAR
###################################################
#New text file button
        self.newtext01_button=Gtk.ToolButton(Gtk.STOCK_EDIT)
        self.newtext01_button.connect("clicked", self.newfile)
        self.newtext01_button.set_label("New text file")
        self.toolbar2.insert(self.newtext01_button, -1)

#New folder button
        self.newfolder01_button=Gtk.ToolButton(Gtk.STOCK_DIRECTORY)
        self.newfolder01_button.connect("clicked", self.newdir)
        self.newfolder01_button.set_label("New folder")
        self.toolbar2.insert(self.newfolder01_button, -1)       

#Separator
        self.separator=Gtk.SeparatorToolItem()
        self.toolbar2.insert(self.separator, -1)

#Copy/Select for moving
        self.copy_button=Gtk.ToolButton(Gtk.STOCK_COPY)
        self.copy_button.connect("clicked", self.movesource)
        self.copy_button.set_label("Copy/Select for moving")
        self.toolbar2.insert(self.copy_button, -1)
# Paste
        self.paste_button=Gtk.ToolButton(Gtk.STOCK_PASTE)
        self.paste_button.connect("clicked", self.copydestination)
        self.toolbar2.insert(self.paste_button, -1)
#Move        
        self.move_button=Gtk.ToolButton(Gtk.STOCK_REFRESH)
        self.move_button.connect("clicked", self.movedestination)
        self.move_button.set_label("Move to location")
        self.toolbar2.insert(self.move_button, -1)
        
#Separator
        self.separator2=Gtk.SeparatorToolItem()
        self.toolbar2.insert(self.separator2, -1)

#Delete permanently button
        self.delete2_button=Gtk.ToolButton(Gtk.STOCK_DIALOG_WARNING)
        self.delete2_button.connect("clicked", self.foreverdelete)
        self.delete2_button.set_label("Delete permanently")
        self.toolbar2.insert(self.delete2_button, -1)
        
#Separator
        self.separator3=Gtk.SeparatorToolItem()
        self.toolbar2.insert(self.separator3, -1)
                                              
#Separator
        self.separator4=Gtk.SeparatorToolItem()
        self.toolbar2.insert(self.separator4, -1)
                
#Separator
        self.separator5=Gtk.SeparatorToolItem()
        self.toolbar2.insert(self.separator5, -1)

#Decompress button
               
        self.decompress_button=Gtk.ToolButton(Gtk.STOCK_OPEN)
        self.decompress_button.connect("clicked", self.decompression)
        self.decompress_button.set_label("Decompress selected archive")
        self.toolbar2.insert(self.decompress_button, -1)
        
#######################        
# Compress Buttons
    
        self.tar1_button=Gtk.ToolButton(Gtk.STOCK_INDENT)
        self.tar1_button.set_label("Compress file or Folder to tar.gz")
        self.tar1_button.connect("clicked", self.targz)               
        self.toolbar2.insert(self.tar1_button, -1)        
        
        self.tar2_button=Gtk.ToolButton(Gtk.STOCK_INDEX)
        self.tar2_button.set_label("Compress file or Folder to tar.bz2")
        self.tar2_button.connect("clicked", self.tarbz2)               
        self.toolbar2.insert(self.tar2_button, -1)
        
        self.zips1_button=Gtk.ToolButton(Gtk.STOCK_EXECUTE)
        self.zips1_button.set_label("Compress file/folder to zip")
        self.zips1_button.connect("clicked", self.zips)               
        self.toolbar2.insert(self.zips1_button, -1)
##############
#RENAME BAR
################
#Rename bar
        self.renamer=Gtk.Entry()

#Rename_Selects button
        self.rbutton1=Gtk.Button("Select for rename ")        
        self.rbutton1.connect("clicked", self.rename_selects)
#Rename_Does button
        self.rbutton2=Gtk.Button("Rename selected")        
        self.rbutton2.connect("clicked", self.actual_rename)             
#####################
####LOCATIION BAR
######################
        self.location1=Gtk.Entry()
        self.location1.connect("activate", self.actual_going)

#Separator
        self.separateus=Gtk.HSeparator()
         
#########################################
#UPPER toolbar buttons and texts
#########################################       
# Unified button
        self.union_button= Gtk.Button("Open File")
        self.union_button.connect("clicked", self.dialog_open)
        
# Simple_mount button
        self.mount_button= Gtk.Button("Open Simple mount")
        self.mount_button.connect("clicked", self.mount)        
################################################################################
#TOOLTIPS FOR BUTTONS UNDER TOOLBAR2
#######################################
#New text or folder
        self.newtext01_button.set_tooltip_text ("Create new text file")
        self.newfolder01_button.set_tooltip_text ("Create new folder")

#Copy/Move and Paste
        self.paste_button.set_tooltip_text ("Paste a copy to location")
        self.copy_button.set_tooltip_text ("Copy/Select for moving")
        self.move_button.set_tooltip_text ("Move object to the location")

#Others                       
        self.tar2_button.set_tooltip_text ("Compress file or folder to tar.bz2")
        self.zips1_button.set_tooltip_text ("Compress file or folder to zip")
        self.tar1_button.set_tooltip_text ("Compress file or Folder to tar.gz")


#Delete Permanently tooltip
        self.delete2_button.set_tooltip_text ("Delete content permanently")
        
#Decompress/Compress
        self.decompress_button.set_tooltip_text ("Decompress tar.gz/tar.bz2/zip archive")
        
        
#More separators
#Separator
        self.separatorx=Gtk.SeparatorToolItem()
################################################################################
#TOOLTIPS FOR BUTTONS UNDER TOOLBAR1
#######################################
        self.union_button.set_tooltip_text ("Open mp3/ogg/jpg/png/txt/pdf/abw/odt/avi/mp4/midi/xcf/mpeg/mp2 files")
        self.mount_button.set_tooltip_text ("Open Simple mount")        	
###########################
#BOX CONTAINERS 
############################
# Vertical box2 for file manager       
        self.vbox2=Gtk.VBox(False)
        self.vbox2.pack_start(self.toolbar2,False, False, 0)
        self.vbox2.pack_start(self.toolbar3,False, False, 0)
        self.vbox2.pack_start(self.toolbar4,False, False, 0)


###Main container1 --- placing stuff to the main window
        self.hbox=Gtk.HBox()
        self.hbox.pack_start(self.union_button, False, False, 1)
        self.hbox.pack_start(self.mount_button, False, False, 1)
        self.hbox.pack_start(self.separatorx, False, False, 1)
        self.hbox.pack_start(self.renamer, False, False, 1)
        self.hbox.pack_start(self.rbutton1, False, False, 1)
        self.hbox.pack_start(self.rbutton2, False, False, 1)
        self.hbox.pack_start(self.separateus, False, False, 1)

        
        ###Location bar container
        self.hbox2=Gtk.HBox()
        self.hbox2.pack_end(self.location1,True, True, 2)

 		#Vertical box/buttons container
        self.vbox=Gtk.VBox(False)
        
        self.vbox.pack_start(self.bar, False, False, 1)   
        self.vbox.pack_start(self.hbox, False, False, 2)
        self.vbox.pack_start(self.hbox2, False, False, 2)
        self.vbox.pack_start(self.filea, False, False, 2)
        self.vbox.pack_start(self.vbox2, False, False, 2)

#Show everything		
        self.window1.add(self.vbox)
        self.window1.show_all()
         
#Making window resizable and enabling the close window connector        
        self.window1.set_resizable(True)
        self.window1.connect("destroy", self.destroy)

def main():
    Gtk.main()
    return 0

if __name__ == "__main__":
    CrosslinkerFM()
    main()
